! Apply lowcut operator
program low_cut

  use sep
!  use lowcut_mod
  use laplac21

  implicit none

  integer                           :: n1, n2, n3, j3
  real                              :: o1, d1, o2, d2, o3, d3, rho
  logical                           :: adj
  real, allocatable, dimension(:,:,:) :: temp1, temp2
  real, allocatable, dimension(:)   :: model, data

  call sep_init()

  call from_history("n1", n1)
  call from_history("o1", o1)
  call from_history("d1", d1)
  call from_history("n2", n2)
  call from_history("o2", o2)
  call from_history("d2", d2)
  call from_history("n3", n3,1)
  call from_history("o3", o3,1.)
  call from_history("d3", d3,1.)

  call from_param("adj", adj)
  call from_param("rho", rho)

  call to_history("n1", n1)
  call to_history("o1", o1)
  call to_history("d1", d1)
  call to_history("n2", n2)
  call to_history("o2", o2)
  call to_history("d2", d2)
  call to_history("n3", n3)
  call to_history("o3", o3)
  call to_history("d3", d3)

  allocate(temp1(n1,n2,n3))
  allocate(temp2(n1,n2,n3))
  allocate(model(n1*n2))
  allocate(data(n1*n2))
  model = 0.
  data = 0.

  call laplac2_init(n1, n2)
!  call lowcut_init(n1, n2, rho)

  if(adj) then
    call sep_read(temp1)
    do j3=1,n3
      data=reshape(temp1(:,:,j3),(/n1*n2/))
!      call lowcut_op2(adj, .false., model, data)
      call laplac2_lop2(.true., .false., model, data)
      temp2(:,:,j3)=reshape(model,(/n1,n2/))
    end do
    call sep_write(temp2)
  else
    call sep_read(temp1)
    do j3=1,n3
      model=reshape(temp1(:,:,j3),(/n1*n2/))
!      call lowcut_op2(adj, .false., model, data)
      call laplac2_lop2(.false., .false., model, data)
      temp2(:,:,j3)=reshape(data,(/n1,n2/))
    end do
    call sep_write(temp2)
  end if
  call sep_close()

end program
