#include "read.h"
#include "map.h"
#include <vector>

void map(Read &par,std::vector<float> &Idata,
                   std::vector<float> &Imodel) {
//  #pragma omp parallel for
  for(int jgx=par.pad; jgx<par.nkgx-par.pad; jgx++){
    int k=jgx-par.pad;
    float fx = 1.+(par.sgx[k]-0.0)/par.dx;
    int jx = fx;
    if(jx >= par.first_cdp && jx <= par.last_cdp) {
      for(int jh=0; jh<2*par.nh+1; jh++){
//        #pragma omp simd
        for(int jz=par.pad+par.zpad; 
                jz<par.nz+par.pad+par.zpad; jz++) {
          int j1=jz+jh*par.nkz+jgx*(2*par.nh+1)*par.nkz;
          int j2=jz-par.pad-par.zpad+
                 jh*par.nz+
                 (jx-par.first_cdp)*(2*par.nh+1)*par.nz;
          Imodel[j2]=Idata[j1];
        }
      }
    }
  }
}

