#include "read.h"
#include "alloc.h"
#include <vector>
#include "vshot.h"
#include "rshot.h"
#include "seplib.h"
#include "sep3d.h"
#include "sep_pars_external.h"
#include <iostream>

void RShot::rshot_init(Read &par) {
  // Allocate auxiliary arrays
  alloc(pR,par.nkgx,par.nkz);  
  alloc(r,par.nx,par.nz);  

  // Initialize inherited vshot
  vshot_init(par);
}

void RShot::rshot(Read &par,std::vector<float> &rshot,float *sgx) {

//  if(par.adj == 1) {
    for(int jh=0; jh<2*par.nh+1; jh++) {
      for(int jx=0; jx<par.nx; jx++) {
       for(int jz=0; jz<par.nz; jz++) {
         r[jx][jz]=par.refl[jx][jh][jz];
        }
      }

      // Create the reflectivity frames with inherited vshot
      vshot(par,r,pR,sgx,0);

      for(int jgx=0; jgx<par.nkgx; jgx++) {
        for(int jz=0; jz<par.nkz; jz++) {
          int jj=jz+jh*par.nkz+jgx*(2*par.nh+1)*par.nkz;
          rshot[jj]=pR[jgx][jz];
        }
      }
    }
//  }
//  else {
//    for(int jx=0; jx<par.nx; jx++) {
//      for(int jz=0; jz<par.nz; jz++) {
//        r[jx][jz]=par.refl[jx][par.nh][jz];
//      }
//    }
//    // Create the reflectivity frames with inherited vshot
//    vshot(par,r,pR,sgx,0);
//    for(int jgx=0; jgx<par.nkgx; jgx++) {
//      for(int jz=0; jz<par.nkz; jz++) {
//        int jj=jz+par.nh*par.nkz+jgx*(2*par.nh+1)*par.nkz;
//        rshot[jj]=pR[jgx][jz];
//      }
//    }
//  }
}
