#include <vector>
#include "solver_report.h"
#include "dot_prodf.h"
#include <numeric>
#include <iostream>
#include <math.h>

double scale;
void solver_report(int iter,std::vector<float> &m,
                            std::vector<float> &g,
                            std::vector<float> &Rd,
                            std::vector<float> &Rm) {
//  double dm=inner_product(m.begin() ,m.end() ,m.begin(),0.0);
//  double dg=inner_product(g.begin() ,g.end() ,g.begin(),0.0);
//  double dd=inner_product(Rd.begin(),Rd.end(),Rd.begin(),0.0);
//  double dRm=inner_product(Rm.begin(),Rm.end(),Rm.begin(),0.0);
  double dm= dot_prodf(m,m);
  double dg= dot_prodf(g,g);
  double dd= dot_prodf(Rd,Rd);
  double dRm=dot_prodf(Rm,Rm);
  if(iter == 1) {
    scale=std::max(dd,dRm)/1000.;
    std::cout << "DOT PRODUCT VALUES SCALED BY " << scale << std::endl;
  }

  std::cout << "Iteration " << iter
            << ", <rd,rd> " << dd
            << ", <rm,rm> " << dRm
            << ", <m,m> "   << dm
            << ", <g,g> "   << dg
            << ", Scl: <rd,rd> " << int(dd/scale)
            << ", <rm,rm> " << int(dRm/scale)
            << ", <m,m> "   << int(dm/scale)
            << ", <g,g>   " << int(dg/scale) << std::endl;
}
