#include "read.h"
#include "vshot.h"
#include "tconv.h"
#include "tconvW.h"
#include <vector>
#include "alloc.h"
#include "allocv.h"
#include <iostream>

void ConvW::tconvW_init(Read &par,
                        std::vector<float>& bc) {
  tconv.tconv_init(bc);

  // Allocate vectors
  allocV(s20,par.nkgx*par.nkz);

  // Create velocity frames
  float **V;
  alloc(V,par.nkgx,par.nkz);
  vel.vshot_init(par);
  vel.vshot(par,par.Vint,V,par.sgx,0);

  // Convert into slowness squared
  for(int jgx=0; jgx<par.nkgx; jgx++) {
    for(int jz=0; jz<par.nkz; jz++) {
      int jj=jz+jgx*par.nkz;
      s20[jj]=par.eps/V[jgx][jz]/V[jgx][jz];
    }
  }
  delete V;
}

int ConvW::tconvW(int adj,int add,std::vector<float> &m,
                                  std::vector<float> &d) {
  std::vector<float> m_total(m.size(),0.);
  std::vector<float> d_total(d.size(),0.);
  if(adj==1) {
    for(int jj=0; jj<d.size(); jj++) {
      d_total[jj]=s20[jj]+d[jj];
    }
    tconv.tconv(1,add,m,d_total);
//    for(int jj=0; jj<m.size(); jj++) {
//      m[jj]=m_total[jj]-s20[jj];
//    }
  }
  else {
    for(int jj=0; jj<m.size(); jj++) {
      m_total[jj]=s20[jj]+m[jj];
    }
    tconv.tconv(0,add,m_total,d);
//    for(int jj=0; jj<d.size(); jj++) {
//      d[jj]=d_total[jj]-s20[jj];
//    }
  }
  int stat=0;
  return stat;
}
