// This is a CPP version of the Fortran module "base_trist_mod"
#include<vector>
#include "base_trismt.h"
#include "seplib.h"

int base_tris1d_oper(std::vector<float> &field,
                     int n1, int rect1, int nsmt) {
  std::vector<float> temp(n1);
  for(int ismt=1; ismt<nsmt; ismt++) {
    if(rect1>1 && n1>1) {
      triangle(rect1,1,n1,field,temp);
      field.swap(temp);
    }
  }
  int stat=0;
  return stat;
}

int base_tris2d_oper(std::vector<float> &field,
                   int n1,int n2,int rect1,int rect2,int nsmt) {
  std::vector<float> temp1(n1);
  std::vector<float> temp1a(n1);
  std::vector<float> temp2(n2);
  std::vector<float> temp2a(n2);
  for(int ismt=1; ismt<nsmt; ismt++) {
    if(rect1>1 && n1>1) {
      for(int j2=0; j2<n2; j2++) {
        for(int j1=0; j1<n1; j1++) {
          int jj=j1+j2*n1;
          temp1a[j1]=field[jj];
        }
        triangle(rect1,1,n1,temp1a,temp1);
        for(int j1=0; j1<n1; j1++) {
          int jj=j1+j2*n1;
          field[jj]=temp1[j1];
        }
      }
    }
    if(rect2>1 && n2>1) {
      for(int j1=0; j1<n1; j1++) {
        for(int j2=0; j2<n2; j2++) {
          int jj=j1+j2*n1;
          temp2a[j2]=field[jj];
        }
        triangle(rect2,1,n2,temp2a,temp2);
        for(int j2=0; j2<n2; j2++) {
          int jj=j1+j2*n1;
          field[jj]=temp2[j2];
        }
      }
    }
  }
  int stat=0;
  return stat;
}

void triangle(int nr,int m1,int n12,
              std::vector<float>& U,
              std::vector<float>& V) {
  std::vector<float> P(n12+nr-1);
  std::vector<float> Q(n12+nr+nr-2);
  std::vector<float> T(n12);
  for(int j1=0; j1<n12; j1++) {
    int jj=0+j1*m1;
    Q[j1]=U[jj];
  }

  if(n12 == 0) {
    T[0] = Q[0];
  }
  else {
    boxconv(nr,n12,Q,P);
    int np=nr+n12-1;
    boxconv(nr,np,P,Q);
    for(int jj=1; jj<=n12; jj++) {
      T[jj-1]=Q[jj+nr-2];
    }
    for(int jj=1; jj<=nr-1; jj++) {
      T[jj-1]+=Q[nr-1-jj];
    }
    for(int jj=1; jj<=nr-1; jj++) {
      T[n12-jj]+=Q[n12+(nr-1)+jj-1];
    }
  }
  for(int j1=0; j1<n12; j1++) {
    int jj=0+j1*m1;
    V[jj]=T[j1];
  }
}

void boxconv(int nb,int nx,
            std::vector<float> &X,
            std::vector<float> &Y) {
  std::vector<float> B(nx+nb,0.);
  if(nb < 1 || nb > nx) {
    seperr("boxconv: Error!");
  }
  int ny = nx+nb-1;
//  for(int jj=0; jj<ny; jj++) {
//    B[jj] = 0.;
//  }
  B[0]=X[0];
  for(int jj=1; jj<nx; jj++) {
    B[jj] = B[jj-1]+X[jj];
  }
  for(int jj=nx; jj<ny; jj++) {
    B[jj] = B[jj-1];
  }
  for(int jj=0; jj<nb; jj++) {
    Y[jj] = B[jj];
  }
  for(int jj=nb; jj<ny; jj++) {
    Y[jj] = B[jj]-B[jj-nb];
  }
  for(int jj=0; jj<ny; jj++) {
    Y[jj] = Y[jj]/nb;
  }
}
