#include "read.h"
#include "lap.h"
#include "grad.h"
#include "vshot.h"
#include "rshot.h"
#include "wave_prop.h"
#include "scatter.h"
#include "scale.h"
#include "born.h"
#include "rtm.h"
#include "operator.h"
#include "born_op.h"
#include <vector>
#include <iostream>

Born_op::Born_op(Read &par_in,Rtm &rtm_in,Born &born_in,WaveProp &fwd,WaveProp &bwd,WaveProp &scat) {
  par=&par_in;
  rtm=&rtm_in;
  born=&born_in;
  nt=(*par).nt;
  nkz=(*par).nkz;
  nkgx=(*par).nkgx;
  nz=(*par).nz;
  nx=(*par).nx;
  nh=(*par).nh;
  eic=(*par).eic;
  (*born).born_init(*par,fwd,scat);
  (*rtm).rtm_init(*par,fwd,bwd);
}

Born_op::~Born_op() {}

void Born_op::op(int adj,int add,
                      std::vector<float> &model,
                      std::vector<float> &data) {
  if(adj == 1) {
    if(add == 0) {
      for(int jj=0; jj<model.size(); jj++) {
        model[jj] = 0.0;
      }
    }
    (*par).rcv=data;
    (*rtm).rtm(*par);
    for(int jj=0; jj<model.size(); jj++) {
      model[jj] += (*rtm).num[jj];
    }
  }
  else {
    if(add == 0) {
      for(int jj=0; jj<data.size(); jj++) {
        data[jj] = 0.0;
      }
    }
    (*born).rshot = model;
    (*born).born(*par);
    for(int jj=0; jj<data.size(); jj++) {
      data[jj] += (*born).dsynt[jj];
    }
  }
}

