#ifndef HESS_OP_H
#define HESS_OP_H
#include "operator.h"

class Hess_op: public Op {
  public:
    Hess_op(Read&,InterpPsf&,int);
   ~Hess_op();
    void op(int,int,std::vector<float>&,
                    std::vector<float>&);

  private:
    void interp_hess(int,int,std::vector<float>&,
                             std::vector<float>&);

    int incPSFx, incPSFz;
    int nx, nkgx, nxE, nh, nz, nkz, nzE, nxc,nzc, nlagx, nlagz;
    int hmax, dh, first_cdp, last_cdp, pad, zpad;
    float dx, dz, fx;
    float **xz, **d, ***m; //,***Hgn;
    std::vector<float> zero, diagH, Hgn; //, psf;
    Read par;
    Write out;
    LInt2 lint2;
    InterpPsf *psf;
};

#endif
