#ifndef READ_H
#define READ_H
#define UNDEFINED -9999.0
#include <string>
#include <vector>

class Read {
  public:
    void read_parameters();
    void read_history();
    void read_headers();
    void read_velocity();
    void read_reflectivity();
    void read_refl_hess(int);
    void read_pert(int);
    void vel_frames(std::vector<float>&,int);
    void refl_frames(std::vector<float>&);
    void read_mask(std::vector<float>&);
    void courant();
    void read_src(int);
    void build_geometry();
    void data_geometry();
    void read_shot(int);
    void verbose_par();

    int ntData, nt, ntsData, nts, nz, nzE, nx, nxE, ngx, hmax;
    int niter, niterH, nreboot, niterW;
    int nbox, nkz, nkgx, ngeof, nh, npts, nthreads;
    int first_cdp, last_cdp, first_source, last_source;
    int napL, napR, napLY, napRY, trace_shot, shot_pos, nsources, ntracesData, ntraces, scatStep;
    int first_geof, last_geof, jgeof, pad, zpad, src_pad, pad_extra, dh;
    int scalco, ntSnap, jtSnap, datumS, datumR, jiter;
    int nlagz, nlagx, incPSFz, incPSFx, npsfx, npsfz, tIntFact;
    int use_taper, dipole, keep_shots, adj, cur_shot, eic, rbc, dot_prod;
    int extend, dso, neg_dso, psf_born;
    int *source_index;
    float dtData, dt, dz, dx, dy, dsx, dgx, dgxOdx, o1, o2, d2, d3;
    float sgx_min, sgx_max, osx, ogx, hsx_cur, hsx_next, hgx_cur, hgx_next, hmin;
    float vel_frac, time_frac, Vmin, Vmax, Vcte, cfl, t_end, fc, fNyq;
    float ox_shift, apertureL, apertureR, cos2thc, alpha, eps, lambda, rand_coeff;
    float scalcof, factX, factZ;
    std::vector<float> Vint, refl, src, src_aux, rcv, rcv2Der;
    float *sx, *gx, *sgx, *hoff;
//    std::vector<float> sx, gx;
    char char_aux[150];
    std::string wavelet_fn, reflfile, datafile, projpref;
    std::string unit1, unit2;

  private:
    void geom_numbers();
    void geom_matrix();

    int src_delay, verb_src, k, l;
    int ngx_prev, ngx_cur, nxpad, nypad, thetac;
    int scalco_key, sx_key, gx_key, sy_key, gy_key, n_keys_data, n_keys_vel;
    int next_header_out, previous_trace;
    float **header_in;
};

#endif
