#ifndef RTM_H
#define RTM_H
#include "allocv.h"
#include "scale.h"

# define PI 3.1415926535897932 // The Order of Chaos

class Rtm {
  public:
    void rtm_init(Read&,WaveProp&,WaveProp&);
    void rtm(Read&);
    void build_images(Read);

    std::vector<float> num, den, numE, ICorr, IEIC;

  private:

    int hmax, use_taper, add, eic, dipole;
    int nt, ntSnap, nx, nxE, nkgx, nh, nz, nzE, nkz, npts, napL, napR;
    int dh, first_cdp, last_cdp, pad, zpad, datumS, datumR, shot_pos;
    int jsrc1, jsrc2;
    float dt, dx, dz, fx;
    float **ptemp;
    WaveProp *fwd, *bwd;
//    Grad grad;
    Scale scaleS, scaleR;
    Scatter scatter;
};


#endif
