#include "read.h"
#include "snap.h"
#include <vector>
#include "seplib.h"
#include "sep3d.h"
#include "sep_pars_external.h"
#include <iostream>

void snapshot(Read &par,int jt,
     std::vector<float>&p,int add,char *outSnap) {
  // Save snapshots of propagation wavefield
  int n=par.nzE*par.nxE;
  std::vector<float> pSnap(n,0.);
  if(remainder(jt,par.jtSnap)==0){
    if(add == 1) par.ntSnap++;
    #pragma omp parallel for
    for(int jgx=0; jgx<par.nkgx; jgx++) { 
      int jx=floor(par.sgx[jgx]/par.dx); //+par.pad+par.napL;
      if(jx>=0 && jx<par.nxE) {
        #pragma omp simd
        for(int jz=0; jz<par.nkz; jz++) {
          int j1=jz+jx*par.nzE;
          int j2=jz+jgx*par.nkz;
          pSnap[j1]=p[j2];
        }
      }
    }
    
    if(4*n != srite(outSnap,pSnap.data(),4*n))
      seperr("snapshot: Have trouble writing trace");
  }
}
