#ifndef WEMVA_H
#define WEMVA_H
#include <vector>

class Wemva {
  public:
    void wemva_init(Read&,WaveProp&,WaveProp&,WaveProp&);
    void wemva(Read&);
    void build_pert(Read);

    std::vector<float> pshot;
    std::vector<float> pert,pertE;
    std::vector<float> IPert,IPertE;

 private:
    int hmax, use_taper, dipole;
    int nt, nx, nxE, nkgx, nh, nz, nzE, nkz, napL, napR;
    int dh, first_cdp, last_cdp, pad, zpad, datumS, datumR;
    int jsrc1, jsrc2;
    float dt, dx, dz;
    std::vector<float> rcv_scl, scat_scl;
//    std::vector<float> paux1, paux2, paux3;
    WaveProp *fwd, *bwd, *scat;
//    Grad grad;;
    Scale scaleS, scaleR, scaleScat;
    Scatter scatterS, scatterR;
};

#endif
