#ifndef WRITE_H
#define WRITE_H

class Write {
  public:
    void write_init(Read); 
    void write_image(Read,float*,char*);
    void write_pert(Read,float*,char*);
    void write_psf(Read,float*);
    void write_data(Read,std::vector<float>,char*);
    void write_data_headers(Read,char*);
    void write_error_res(Read,int,float*,char*);
    void write_hess_image(Read,float*,int);
    void write_snap(char*);

  private:
    void write_vshot();
    void write_amp(char*);

    int one=1;
    int two=2;
    int ntData, nt, ntSnap, nx, nxE, ngx, nkgx, nh, nz, nzE, nkz, napL, napR, niterH;
    int non_zero, pad, zpad, jtSnap, first_cdp, key, tIntFact;
    float zero=0.0;
    float onef=1.0;
    float dh, oh, amp_min, amp_max, amp_rms, amp_mean, scalcof;
    float dtData, dt, dx, dz, o1, o2;
    float *Data;
    float ** header_out;
    char *char_aux;
};

#endif
