#!/usr/local/bin/python
from mpl_toolkits.mplot3d import Axes3D
import matplotlib.pyplot as plt
import numpy as np
import sepbase
import subprocess
import sys
sys.path.insert(0,'/data/sep/cabrales/generic_solvers/python_solver')
import sep_python as sep

### This is a small funtion to plot the impulse model as a surface

eq_args_from_cmdline,args = sepbase.parse_args(sys.argv)
input_file=eq_args_from_cmdline['input_file']

proc=subprocess.Popen(['Get < %s parform=n o1' %(input_file)],stdout=subprocess.PIPE,shell=True)
(o1,err)=proc.communicate();
print "o1: %s" %(o1)
proc=subprocess.Popen(['Get < %s parform=n d1' %(input_file)],stdout=subprocess.PIPE,shell=True)
(d1,err)=proc.communicate();
print "d1: %s" %(d1)
proc=subprocess.Popen(['Get < %s parform=n n1' %(input_file)],stdout=subprocess.PIPE,shell=True)
(n1,err)=proc.communicate();
print "n1: %s" %(n1)

proc=subprocess.Popen(['Get < %s parform=n o2' %(input_file)],stdout=subprocess.PIPE,shell=True)
(o2,err)=proc.communicate();
print "o2: %s" %(o2)
proc=subprocess.Popen(['Get < %s parform=n d2' %(input_file)],stdout=subprocess.PIPE,shell=True)
(d2,err)=proc.communicate();
print "d2: %s" %(d2)
proc=subprocess.Popen(['Get < %s parform=n n2' %(input_file)],stdout=subprocess.PIPE,shell=True)
(n2,err)=proc.communicate();
print "n2: %s" %(n2)

[data,info]=sep.sep_read_file(input_file)

oz=float(o1)
dz=float(d1)
nz=int(n1)
ox=float(o2)
dx=float(d2)
nx=int(n2)

fig=plt.figure();
ax=fig.add_subplot(1,1,1, projection='3d')
x=np.arange(ox,ox+nx*dx,dx)
z=np.arange(oz,oz+nz*dz,dz)
X,Z=np.meshgrid(x,z)
Amp=data.reshape(X.shape)

#ax.plot_surface(X,Z,Amp)
ax.plot_wireframe(X,Z,Amp,rstride=20,cstride=20)

ax.set_xlabel('X coord')
ax.set_ylabel('Z coord')
ax.set_zlabel('Amplitude')

plt.show()
