#!/usr/bin/python
import copy
import os
import sepbase
import tempfile
import unittest
import re
import math

from batch_task_executor import *
import pbs_util

### An example to define a batch task through inheriting the BatchTaskComposer class.
### IMPORTANT: Read /home/zyang03/script/batch_task_executor.py to learn 
### the detailed specifications/explanations of the interfaces defined in BatchTaskComposer.

class Hessian2dBatchTaskComposer(BatchTaskComposer):
  def __init__(self, param_reader, njobs, nfiles_perjob):
    BatchTaskComposer.__init__(self)
    self.njobs = njobs
    self.nfiles_perjob = nfiles_perjob
    # Create all subjobs info
    self.subjobids = range(0, self.njobs)
    self.subjobfns_list = [None]*self.njobs
    path_out = param_reader.path_out
    args_hessian = eq_args_from_cmdline
    # Create files for each subjob.
    nfiles = self.nfiles_perjob
    self.subjobfns_list[0] = [None]*nfiles
    self.subjobfns_list[0][0] = '%s' % (args_hessian['hessian'])
    print "subjobfns, %s" % (self.subjobfns_list[0][0])
#    for i in range(0,self.njobs):
#       nfiles = self.nfiles_perjob
#       self.subjobfns_list[i] = [None]*nfiles
#       for j in range(0,nfiles):
#          if i < 9:
#            self.subjobfns_list[i][j] = '%s/%s_hessian_00%s.H' % (args_hessian['resdir'], args_hessian['projpref'], i+1)
#          elif i < 99:
#            self.subjobfns_list[i][j] = '%s/%s_hessian_0%s.H'  % (args_hessian['resdir'], args_hessian['projpref'], i+1)
#          elif i < 999:
#            self.subjobfns_list[i][j] = '%s/%s_hessian_%s.H'   % (args_hessian['resdir'], args_hessian['projpref'], i+1)
#          print "subjobfns, %s" % (self.subjobfns_list[i][j])
    return

  def GetSubjobScripts(self, subjobid):
    '''Return the scripts content for that subjob.'''
    subjobfns = self.subjobfns_list[subjobid]
    scripts = []
    # Build scripts that create the files designated in subjobfns\
    jobname = subjobfns[0]
    shots = []
    shots = (re.findall('\d+', jobname ))
    shot_num = 1 #int(shots[0])
  #  sub_shot = int(shots[1])

    args_hessian = eq_args_from_cmdline
    path_out = param_reader.path_out

    prefix = param_reader.prefix

    cmd =  '%s < %s par=%s adj=%s psf=%s extend=%s reflfile=%s ' \
          %(args_hessian['bin'], args_hessian['vel'], args_hessian['par'], args_hessian['adj'], \
            args_hessian['psf'], args_hessian['extend'], args_hessian['reflfile'])
    cmd += '> %s hessian=%s snap1=/dev/null snap2=/dev/null snap3=/dev/null vrandom=/dev/null ' \
             %(args_hessian['log'], args_hessian['hessian'] )

    scripts.append(cmd)
    return scripts, str(subjobid)


  def GetSubjobsInfo(self):
    '''Should return two lists, subjobids and subjobfns.'''
    return copy.deepcopy(self.subjobids), copy.deepcopy(self.subjobfns_list)


if __name__ == '__main__':
  print "Run BatchTaskExecutor_test with params:", sys.argv
  # Check basic environment variable setup.
  assert 'SEP' in os.environ, '!Environment var SEP is not set yet, should have your seplib enviroment set up first! Check paths like /opt/SEP/'
  assert 'RSF' in os.environ, '!Environment var RSF is not set yet, should have your RSF environment set up first! Check paths like /opt/RSF'
  eq_args_from_cmdline,args = sepbase.parse_args(sys.argv)
  #dict_args = sepbase.RetrieveAllEqArgs(eq_args_from_cmdline)
  param_reader = pbs_util.JobParamReader(eq_args_from_cmdline)
  njobs=1 #int(eq_args_from_cmdline['nshots'])
  nfiles_perjob=1
  hessian2d_btc = Hessian2dBatchTaskComposer(param_reader,njobs,nfiles_perjob)
  bte = BatchTaskExecutor(param_reader)
  prefix = param_reader.prefix

  print "Launch the thing..."
  bte.LaunchBatchTask(prefix, hessian2d_btc)

  # Check the final result
  #stat,out = commands.getstatusoutput('Attr < test-all.H param=1 | Get parform=n totsamp ')
  #assert stat==0 and int(out)==4, 'Test NOT successful, final output test-all.H is not valid!'
  print 'GODDAMMIT, WE MADE IT.'
